'****************************************************************
'*  Name    : MyPSU.BAS                                         *
'*  Author  : VLADIMIR YERSHOV AKA KABRON                       *
'*  Notice  : Copyright (c) 2006                                *
'*          : All Rights Reserved                               *
'*  Date    : 19.05.2006                                        *
'*  Version : 1.0                                               *
'*  Notes   : PULSE POWER SUPPLY CONTROLLER PGM                 *
'*          : change TMR1 to TMR0                               *
'*          ; Power stage with TL494                            *
'****************************************************************
 OPTIMISER_LEVEL=5
    Device 18F452 '18F252
    Include "BASIC_INTS.INC"
    Include "defs18.bas"
'=========================================================
    Clear
'    #DEFINE DEBUG_ 
'     #DEFINE INVERT
    '============== SETUP SECTION ========================
    Symbol  BAUD         =57600
'    symbol  FOSC         =10000000  ' For Debug
   Symbol  FOSC         =40000000  ' WITH 10MHZ CRYSTALL AND PLL ON   
    Declare BOOTLOADER   =On
    Declare XTAL         =FOSC/1000000
    Declare LCD_DTPIN    PORTB.4	
    Declare LCD_ENPIN    PORTB.3
    Declare LCD_RSPIN    PORTB.2
    Declare LCD_INTERFACE 4
    Declare LCD_LINES 2
    Declare CCP1_PIN     PORTC.2   ' Select HPWM port and bit for CCP1 module. i.e. channel 1
    Declare CCP2_PIN     PORTC.1   ' Select HPWM port and bit for CCP2 module. i.e. channel 2

    Symbol  U_divider   =3          ' Output voltage divider
    Symbol  I_multip    =25         ' Output current opamp gain 
    Symbol  Ssense      =10         ' Current sense resistor conductivity 1/Om
    Symbol  R_CurrGen   =2.35       ' CURRENT GENERATOR RESISTOR
    Symbol  Vref        =5          ' Reference voltage for PIC ADC 
    Symbol  UacGain     =27         ' GAIN OF AC AMPLIFIER
    Symbol  Idis_MAX    =Vref/R_CurrGen '2.13A
    Symbol  Imax        =(Vref*Ssense)/I_multip
    Symbol  Umax        =Vref*U_divider
    Symbol  Fpwm        =32000      ' PWM FREQ
    Symbol  ADCscale    =1024
    Symbol  PWMscale    =256
    Symbol  ADC_Div     =ADCscale/Vref
    Symbol  UacDiv      =ADC_Div * UacGain
    
    Symbol	   SAMPLERATE=10         ' TIMER1 INTERRUPT INTERVAL Hz   !!! WRONG !!!
    Symbol     TMR0DIV=128
    Symbol     DIVIDER=4* TMR0DIV * SAMPLERATE
    Symbol     F=FOSC/DIVIDER
    Symbol     TMR0LOAD=65536-F
    
    Symbol     SPBR_G=(FOSC-16*BAUD)/(16*BAUD)+0.5 
    Symbol     SPBRG2=1040
    Symbol     SPBRG4=520
    Symbol     SPBRG9=259   '(FOSC-16*9600)/(16*9600)+0.5 
    Symbol     SPBRG19=129  '(FOSC-16*19200)/(16*19200)+0.5
    Symbol     SPBRG38=64   '(FOSC-16*38400)/(16*38400)+0.5
    Symbol     SPBRG57=42   ' (FOSC-16*57600)/(16*57600)+0.5
    Symbol     SPBRG115=21  '(FOSC-16*115200)/(16*115200)+0.5
    ' ===================================================================
       
    Symbol  Buzz        = PORTC.3 
    Symbol  CH_V 	    = %10000001	 ' PortA.0 ADC ON, REAR FROM RA0 ADCCON0
    Symbol  CH_I	    = %10001001  ' PortA.1 ADC ON, READ FROM RA1 ADCCON0	
    Symbol  CH_Iset_m   = %10010001  ' PortA.2 MEASURED Iset
    Symbol  CH_Uac      = %10011001  ' PortA.3 AC voltage on Accu  
    Symbol  Disch_en    =PORTA.4     ' Enable Current Gen for discharge  
    Symbol  ADC_DELAY	= 50		 ' ADC DELAY uS
    Symbol  PWM_I       =2
    Symbol  PWM_U       =1
    Symbol  IsetE       =1           ' EEPROM STORE LOCATIONS
    Symbol  UsetE       =IsetE +1    '
    Symbol  IcalE       =UsetE +1    '
    Symbol  UcalE       =IcalE +4    '
    Symbol  SPBRGE      =UcalE +4 
    Symbol  BRGHE       =SPBRGE +1
    Symbol  IsetCE      =BRGHE +1
    Symbol  IsetC1E     =IsetCE +4
    Symbol  IdchCE      =IsetC1E +4
    
    Symbol  mnuDisp =0               ' MENU ITEMS
    Symbol  mnuSetU =1               '
    Symbol  mnuSetI =2               '
    Symbol  mnuPreS =3               '
    Symbol  mnuCOM  =4               '
    Symbol  mnuCHARGE =5
    Symbol  mnuItems=6
    
    Symbol  mnuCharInit=0
    Symbol  mnuCharSel=1
    Symbol  mnuCharSet=2
    Symbol  mnuCharDisp=3
    Symbol  mnuCharItems=4
     
    Symbol  SLA=2
    Symbol  NiCd=6 
    Symbol  LION=10
    Symbol  ESC=14
    Symbol  cNcell=2
    Symbol  cCap=6
    Symbol  cGO=10
    

    Dim     Per         As Word        ' Period of 0Fh for Autobaud
    Dim     Um          As Word        ' Measured U
    Dim     Im          As Word        ' Measured I
'    dim     Ima         AS WORD
    Dim     Uset        As Word        ' Setting
    Dim     Uset1       As Byte
    Dim     Iset        As Word        '
    Dim     Iset_m      As Word        ' Measured value of Iset
    Dim     IdisSet     As Byte        ' PWM VALUE FOR DISHARGE CURRENT
    Dim     Idis        As Float       '  CALCULATED VALUE FOR DISHARGE CURRENT
    Dim     Watt        As Float
    Dim     Ud          As Float       ' Value to Display
    Dim     Uac_m       As Word        ' Measured Value Uac on Accu
    Dim     Uac         As Float       ' ==='=== for calculations
    Dim     Id          As Float       ' I DISPLAY
    Dim     Ids         As Float       ' Iset FOR DISPLAY
    Dim     Uds         As Float       '
    Dim     Ical        As Float       ' Calibration Values
    Dim     Ucal        As Float       '
    Dim     IsetC       As Float       ' Calibration Iset
    Dim     IsetC1      As Float
    Dim     IdchC       As Float       ' CALIBRATION DISCHARGE CURRENT
    Dim     Ser_Out     As Byte        ' Flags
    Dim Ser_Out_Once    As Byte        '
    Dim     CMD         As Byte        ' 
    Dim     DByte       As Byte
    Dim     PARITY      As Byte 
    Dim     I           As Byte  
    Dim     vv          As Byte
    Dim     TMP         As Word
    Dim     TMP1        As Float 
    Dim     Butt        As Byte
    Dim     CmdMode     As Byte
    Dim     CNT         As Byte
    Dim     Boost       As Byte        ' FAST SCROLL FLAG
    Dim     Menu        As Byte
    Dim     ChargeMenu  As Byte
    Dim     DispON      As Byte
    Dim     Dir         As Byte
    Dim     RTC         As Word
    Dim     SPBRGet     As Byte
    Dim     Strin       As String * 6
    Dim     Timer       As Word
    Dim     Hours       As Byte
    Dim     Minutes     As Byte
    Dim     Secs        As Byte
    Dim     CurPos      As Byte
    Dim     Type        As Byte
    Dim     Ncell       As Byte
    Dim     Cap         As Float 
    Dim     Ah          As Float 
    Dim     UacHi       As Word
    Dim     UacLo       As Word 
    Dim     Sb          As Float   ' BATTRERY CONDUCTIVITY IN Siemens 
    Dim     B_Delay     As Byte  

'==========================================
    ON_INTERRUPT HIGH_INT										 
	ON_LOW_INTERRUPT TMR0_IHR          'TMR1_IHR
'==================INIT====================
'Enable Debug
    DelayMS 1000                ' LETS MICE COME TO LIVE

     IPEN   = 1                 ' Enable priority interrupts.
     TMR0IP = 0
     RCIP   = 1                 ' RxD Int High Priority
     RBIP   = 1                 ' RB Port Change Interrupt Priority High

                                ' FOR HSERIAL
     SPBRG=ERead SPBRGE
     BRGH= ERead BRGHE
#IFDEF debug_     
     SPBRG=SPBR_G
#ENDIF     
           
    ADCON1 =%11000000           'RIGHT justify result Fosc/64, A   A   A   A   A   A  REF+=VDD; REF-=VSS

    CCP1CON=%00001100           'PWM mode
    CCP2CON=%00001100           'PWM mode
    TRISA=%01101111
    TRISB=%11110000
    TRISC=%10110001
'    T0CON=%00000111             ' TMR0 16bit, Prescaller enab, int osc, /256
    T0CON=%00000110             ' TMR0 16bit, Prescaller enab, int osc, /128
'    T0CON=%00000101             ' TMR0 16bit, Prescaller enab, int osc, /64
    Disch_en=1
    Buzz=0    
    GoSub BEEP
'    curpos=1

    Iset.BYTE0=ERead IsetE
    
    Uset.BYTE0=ERead UsetE
    
    Ser_Out=0
    Ser_Out_Once=0
    
    Ical=ERead IcalE
    ICALH=ERead IcalE +1
    ICALHH=ERead IcalE +2
    ICALHHH=ERead IcalE +3
    
    IsetC=ERead IsetCE
    ISETCH=ERead ISETCE+1
    ISETCHH=ERead ISETCE+2
    ISETCHHH=ERead ISETCE+3 

    IsetC1=ERead IsetC1E
    ISETC1H=ERead ISETC1E+1
    ISETC1HH=ERead ISETC1E+2
    ISETC1HHH=ERead ISETC1E+3 
       
    Ucal=ERead UcalE
    UCALH=ERead UcalE +1
    UCALHH=ERead UcalE +2
    UCALHHH=ERead UcalE +3
    
    IdchC=ERead IdchCE
    IDCHCH=ERead IdchCE +1
    IDCHCHH=ERead IdchCE +2
    IDCHCHHH=ERead IdchCE +3            
    
'     IdchC=1.064
    
    Menu=0
    Boost=1
    DispON=1
    Cls
 '   PRINT AT 1,1, "BAUD=", DEC SPBRG
    Print At 2,1, "Ver. Ns 19.07.06"
    DelayMS 1000
    GoSub  INIT_TMR0

    Cls
    INTEDG0=0              ' Interrupt0 on falling edge
    INT1IF=0
    INT0IF=0
    TMR0IF=0

    INT0IE=1
    GIEH=1

    CmdMode=0               ' MODE FOR GET_BYTE SUB   
    GoSub INIT_MOUSE
    CmdMode=1 : CNT=0
    Ncell=1 : Cap=1 : CurPos=2
    
    TMR0IE=1
    PEIE=1
    RCIE=1
    GIEL=1

    GoSub SET_OUT
    GoSub BEEP 
    HRSOut "READY",LF,CR
    
    TMR0ON=1
'ENABLE DEBUG
MAIN_LOOP:
    HRSOut "MAIN LOOP0",CR
    While 1=1
    Timer=RTC
    While RTC - Timer < SAMPLERATE
    Wend
'    HRSOUT "MAIN LOOP1",CR
    GoSub READ_VARS
    GoSub DISPLAY
    GoSub TimeUpdate    
    Wend
'Disable Debug
HIGH_INT: 
    SYSTEM_SAVE
    If INT0IF=1 Then GoSub GET_BYTE   
    If RCIF=1 Then GoSub RXD 
    SYSTEM_RESTORE
retfie

TMR0_IHR:
    SYSTEM_SAVE
    Inc RTC
    TMR0H=TMR0LOAD/256   'TMR0LOAD_H      'TMR0LOAD.highbyte
    TMR0L=TMR0LOAD-TMR0LOAD/256
    SYSTEM_RESTORE
    TMR0IF=0
retfie


DISPLAY:
     
    Ud=Um * Umax/ADCscale
    Ud=Ud * Ucal
    
    Uds=Uset * Umax/PWMscale
    
    Id=Im * Imax/ADCscale
    Id=Id * Ical
    
    Ids=Iset_m * Imax/ADCscale
    Ids=Ids * IsetC + IsetC1
    
    Watt=Ud * Id
    
    If DispON = 0 Then MenuSel 'return

    Print At 1,1, DEC2 (Ud + 0.005),"V  "
    Print At 1,8, DEC3 (Id + 0.0005)',"A "
    Print At 2,1, DEC2 Watt, "W  "
    Print At 2,8, DEC3 Ids',"A   "

    If Menu<> mnuDisp  Then
    If Dir=1 Then
    Print At 1,16, ">"
    Else
    Print At 1,16, "<"
    EndIf
    Else
    Print At 1,13,"A   "
    Print At 2,13,"A   "
    EndIf

    If Ser_Out=1 Then HSerOut [DEC2 Ud+0.005,";",DEC3 Id +0.0005, LF,CR]
    If Ser_Out_Once=1 Then Ser_Out=0 : Ser_Out_Once =0
'======================================== 
MenuSel:   
    Select Menu
        Case mnuDisp
        DispON=1
        Print $FE, $0C                        ' cursor off
        
        Case mnuSetU
        DispON=1
        Print $FE,$0E, $FE,$0F                'Underline cursor on Blinking cursor on
        Print At 2,15,"Us"    
        
        Case mnuSetI
        Print $FE, $0E, $FE, $0F
        Print At 2,15,"Is"
        DispON=1
        
        Case mnuPreS
        Print At 1,1,"Pre NOT READY"
        Print At 2,1,"set    YET"
        
        Case mnuCOM
        DispON=0
        Print At 1,1, "Change BaudRate " 
        Print At 2,1, "Click Mid to GO "
        
        Case mnuCHARGE
                DispON=0
            Select ChargeMenu
                Case  0                
                Print At 1,1, "   CHARGE       "  
                Print At 2,1, "Click Mid to GO " 
                 
                Case 1                
                Print At 1,1, "  SELECT TYPE   "
                Print At 2,1, "SLA NiCd Li  ESC" 
                Print $FE, $C0+CurPos
                
                Case 2 
                    Select Type
                    Case 2
                    Print At 1,2,DEC2 Ncell,"   ",DEC1 Cap,"    SLA"
                    Case 6              
                    Print At 1,2,DEC2 Ncell,"   ",DEC1 Cap,"     Ni"
                    Case 10
                    Print At 1,2,DEC2 Ncell,"   ",DEC1 Cap,"     Li"
                    EndSelect
                Print At 2,1, "Ncell CAP GO ESC"
                Print $FE, $C0+CurPos

                Case 3
'                print at 1,1, "CHARGING... "
                TMP1=Hours + Minutes/60
                Ah=Id * TMP1
                Print At 1,1,DEC2 (Ud + 0.005),"V ", DEC3 (Id + 0.0005),"A"
                Print At 2,1, DEC2 Hours,":",DEC2 Minutes," ",DEC2 Ah,"Ah"
                If Secs=0 Then GoSub TEST_CHARGE
            EndSelect 
    EndSelect
Return

INIT_TMR0:
    T0CON=6      
    RELOAD_TMR0:
    TMR0H=TMR0LOAD/256   'TMR0LOAD_H      'TMR0LOAD.highbyte
    TMR0L=TMR0LOAD-TMR0LOAD/256
Return



READ_VARS:
V_READ:
    Dim Uma As Word
    Dim Ima As Word
    Dim Iset_ma As Word
    Dim Uac_ma As Word                      
    ADCON0=CH_V
    DelayUS ADC_DELAY
    ADCON0.2 = 1
    While  ADCON0.2 = 1
    Wend
    Um.HighByte = ADRESH
    Um.LowByte = ADRESL
    Uma=(Uma + Um)>>1
    Um=Uma
        
    DelayUS 5

I_READ:
  
    ADCON0=CH_I
    DelayUS ADC_DELAY
    ADCON0.2 = 1
    While  ADCON0.2 = 1
    Wend
    Im.HighByte = ADRESH
    Im.LowByte = ADRESL
    Ima=(Ima +Im)>>1
    Im=Ima
    DelayUS 5
    
I_set_m_Read:
    ADCON0=CH_Iset_m
    DelayUS ADC_DELAY
    ADCON0.2 = 1
    While  ADCON0.2 = 1
    Wend
    Iset_m.HighByte = ADRESH
    Iset_m.LowByte = ADRESL  
    Iset_ma=(Iset_ma + Iset_m)>>1
    Iset_m=Iset_ma          
    DelayUS 5
        
Uac_Read:
    ADCON0=CH_Uac
    DelayUS ADC_DELAY
    ADCON0.2 = 1
    While  ADCON0.2 = 1
    Wend
    Uac_m.HighByte =ADRESH
    Uac_m.LowByte = ADRESL 
 '   UAC_MA=(UAC_MA +UAC_M)>>1           
 '   UAC_M=UAC_MA
Return

RXD:
    CMD=RCREG
    Select CMD
    Case "D"            ' SEND U, I TO SERIAL ONCE
    GoSub BEEP
    Ser_Out=1
    Ser_Out_Once=1
    Case "C"            ' SEND U, I TO SERIAL CONTINIOUSLY
    GoSub BEEP
    Ser_Out=1
    Ser_Out_Once=0
    Case "R"            ' STOP SENDING U,I
    GoSub BEEP
    Ser_Out=0
    Case "I"            ' CALIBRATE I
    GoSub BEEP
    GoSub I_CALL
    Case "U"            ' CALIBRATE U
    GoSub BEEP
    GoSub U_CALL
    Case "S"            ' SEND CURRENT SETTINGS
    GoSub Settings
    Case "T"            ' PERFORM LINEARITY TEST
    GoSub Test_U
    Case "Y"
    GoSub Test_I
    Case "K"            ' ISET CAL
    HRSOut "MAKE SHURE CURRENT IS LIMITED, HIT ANY DIGIT",LF,CR
    HRSin DEC1 I
    
    GoSub Iset_CAL
    
    Case "B"            ' RESET CALIBRATIONS TO 1
    HRSOut "DISCHARGER TEST",LF,CR
    GoSub GET_Uac
    GoSub CALC_Sb
    HRSOut "IdS=", DEC3 Iset_m * IdchC + IsetC1," Uac=",DEC3 Uac," Sb=", DEC4 Sb,LF,CR
    
    Case "L"            ' CALIBRATE DISCHARGE CURRENT
    GoSub Idis_CAL
    
    Case "E"
    GoSub TEST_CHARGE
    
    Case "F"
    GoSub TEST_DISCHARGE
     
    Case 0
    GoSub BEEP
 '   IF AUTOBAUD=0 THEN
    Cls
    Print At 1,1, "BOOTLOADER MODE!" 
    reset  
'    ENDIF             ' AUTOSTART BOOTLOADER IF MCLOADER TRYING TO CONNECT '@GOTO 0
    Case "?"
    GoSub Help
    Case "u"
    HRSin DEC3 Uset
    HRSOut DEC3 Uset,CR,LF
    GoSub SET_OUT
    Case "i"
    HRSin DEC3 Iset
    HRSOut DEC3 Uset,CR,LF
    GoSub SET_OUT
    
    Case Else
    GoSub BEEP
    End Select
    If OERR=1 Then CREN=0
    CREN=1
    CMD=RCREG : CMD=RCREG
Return

TEST_CHARGE:
'     HPWM PWM_u,0,FPWM
     DelayMS 20
     GoSub GET_Uac
     GoSub CALC_Sb
     HRSOut DEC2 Hours,":",DEC2 Minutes," ; ",DEC2 Ud," ; ",DEC3 Id," ; ", DEC4 Sb,CR
     GoSub SET_OUT      
Return

TEST_DISCHARGE:
     
     
Return               

CALC_Sb:
        
     Sb=  UacDiv * Ids   'Sb=UacDiv*Ids*IdchC/Uac
     Sb=Sb * IdchC
     Sb=Sb /Uac
       
Return

SET_OUT:
    HPWM PWM_I,Iset.BYTE0,Fpwm
    EWrite IsetE, [Iset.BYTE0]
    HPWM PWM_U, Uset.BYTE0,Fpwm   
    EWrite UsetE, [Uset.BYTE0]
Return
     ' CALIBRATIONS SUBS
U_CALL:
    GIEH=0: GIEL=0
    Ucal=1
'    GOSUB SAVE_UC
'    GOSUB SAVE_IC
'    HRSOUT "CALIBRATIONS RESETED",LF,CR
    
    Dim Ucc As Float
    
    Dim Ii As Byte
    For Ii=1 To 10
    GoSub READ_VARS
    Ucc=Ucc + Um
    Next Ii
    Ucc=Ucc/10
    Ucc=Ucc * Umax/ADCscale
    Ucc=Ucc * Ucal
    
    HSerOut ["U=",DEC2 UCC+0.005, LF,CR, "ENTER U 4 DIGITS NO POINT",LF,CR]
    HSerIn [DEC4 Ud]
    HSerOut [DEC2 Ud,LF,CR]
    Ucal=(Ud/100)/Ucc

Save_Uc:
    HSerOut ["Ucal=", DEC3 Ucal, LF,CR]
    EWrite UcalE, [Ucal]
    EWrite UcalE +1, [UCALH]
    EWrite UcalE +2, [UCALHH]
    EWrite UcalE +3, [UCALHHH]    
    GIEH=1: GIEL=1 
Return

I_CALL:
    GIEH=0: GIEL=0
    Ical=1
'    GOSUB SAVE_UC
'    GOSUB SAVE_IC
'    HRSOUT "CALIBRATIONS RESETED",LF,CR
    
    Dim Icc As Float
    
    For Ii=1 To 10
    GoSub READ_VARS
    Icc=Icc + Im
    Next Ii
    
    Icc=Icc/10
    Icc=Icc * Imax
    Icc=Icc/ADCscale
    Icc=Icc * Ical
    Icc=Icc * Ical +0.0005
    HSerOut ["I=", DEC3 Icc, LF,CR, "ENTER I 4 DIGITS NO POINT",LF,CR]
    HSerIn [DEC4 Id]
    HSerOut [DEC3 Id,LF,CR]
    Ical=(Id/1000)/Icc
    
Save_Ic:
    HSerOut ["Ical=", DEC3 Ical, LF,CR]
    EWrite IcalE, [Ical]
    EWrite IcalE +1, [ICALH]
    EWrite IcalE +2, [ICALHH]
    EWrite IcalE +3, [ICALHHH]    
    GIEH=1: GIEL=1 
Return

Iset_CAL: 
    Dim Id1 As Float
    Dim Ism1 As Float
    GIEH=0: GIEL=0
    HPWM PWM_U, 128,Fpwm
    HPWM PWM_I, 0,Fpwm
    DelayMS 200
    IsetC=1 :IsetC1=0
    Id1=0 : Ism1=0
    
    For I=1 To 20
    GoSub READ_VARS
    
    Id=Im * Imax/ADCscale    
    Id=Id * Ical    
    Id1=Id1 + Id
    
    Ids= Iset_m * Imax/ADCscale
    Ids=Ids * IsetC
    Ids=Ids + IsetC1
    Ism1=Ism1 + Ids
    
    Next I
    
    Id1=Id1/20
    Ism1=Ism1/20
    IsetC1=Id1 - Ism1
    
    HPWM PWM_U, 255,Fpwm
    HPWM PWM_I, 250,Fpwm
    DelayMS 200
    
    For I=1 To 20
    GoSub READ_VARS
    
    Id=Im * Imax/ADCscale
    Id=Id * Ical
    Id1=Id1 + Id
    
    Ids= Iset_m * Imax/ADCscale
    Ids=Ids * IsetC
    Ids=Ids + IsetC1
    Ism1=Ism1 + Ids
    
    Next I
    
    Id1=Id1/20
    Ism1=Ism1/20
    IsetC=Id1 - IsetC1
    IsetC=IsetC/Ism1
                
Save_IsetC:
    EWrite IsetCE,    [IsetC]
    EWrite IsetCE +1, [ISETCH]
    EWrite IsetCE +2, [ISETCHH]
    EWrite IsetCE +3, [ISETCHHH]
    
    EWrite IsetC1E,    [IsetC1]
    EWrite IsetC1E +1, [ISETC1H]
    EWrite IsetC1E +2, [ISETC1HH]
    EWrite IsetC1E +3, [ISETC1HHH]

    
    HRSOut "Iset CALIBRATION DONE",CR
    GoSub SET_OUT
    GIEH=1: GIEL=1   
Return

Idis_CAL:
    GIEH=0: GIEL=0
'    IdchC=1
    HPWM PWM_U, 0,Fpwm
'    ISET=ISET * IdchC
'    HPWM PWM_I, ISET * IdchC ,FPWM
'    
    Disch_en=0
    HSerOut ["IdCH=", DEC3 Ids * IdchC, LF,CR, "ENTER I DISCHARGE 4 DIGITS NO POINT",LF,CR]
    HSerIn [DEC4 Id]
    Id=Id/1000 +0.0005
    HSerOut [DEC3 Id,LF,CR]    
    IdchC=Id/Ids
    Disch_en=1
Save_IDIS_CAL:
    HSerOut ["Idis_CAL=", DEC3 IdchC," Idch=", Dec Ids * IdchC, LF,CR]
    EWrite IdchCE, [IdchC]
    EWrite IdchCE +1, [IdchCH]
    EWrite IdchCE +2, [IdchCHH]
    EWrite IdchCE +3, [IdchCHHH] 
    GoSub SET_OUT   
    GIEH=1: GIEL=1          
Return    

GET_Uac:  'GET_Sb:
'    GIEH=0: GIEL=0
GET_Uac1:
    UacLo=0: UacHi=0
    HPWM PWM_U, 0,Fpwm     ' ZERO OUTPUT VOLTAGE
    DelayMS 50

    GoSub PRECHARGE
    
    Disch_en=0        'TURN DISCHARGE ON
    For vv=1 To 2                     
    DelayMS 1
    GoSub Uac_Read
    UacLo=UacLo +Uac_m
    Next vv
    UacLo=UacLo>>1
    
    Disch_en=1                 'TURN DISCHARGE OFF
    For vv=1 To 2
    DelayMS 1
    GoSub Uac_Read
    UacHi=UacHi + Uac_m
    Next vv
    UacHi=UacHi>>1
    Uac=UacHi - UacLo
'    HRSOUT "Iset=", DEC iset, " UacHi=",DEC UACHI," UacLo=",DEC UACLO," Uac=",DEC3 UAC,cr
    GoSub SET_OUT
'    GIEH=1: GIEL=1
Return     
PRECHARGE:
    For vv=1 To 8
    Disch_en=0
    DelayMS 10
    Disch_en=1
    DelayMS 10
    Next vv
Return                   

Include      "mouse_sub.bas"

Change_Baud:
    Print At 1,1, "Change BaudRate"
    Print At 2,1, "Now send me 0Fh"
    While 1=1
    Call get_spbrg 
    If Per=0 Then OnceAg
    If Abs(Per -SPBRG2)<=2  Then  BRGH=0: Per=255 : Strin= "2400"  : GoTo ExitOK
    If Abs(Per -SPBRG4)<=2  Then  BRGH=0: Per=Per>>2 : Strin= "4800"  : GoTo ExitOK
    If Abs(Per -SPBRG9)<=2  Then  BRGH=0: Per=Per>>2 : Strin= "9600"  : GoTo ExitOK
    If Abs(Per -SPBRG19)<=2 Then  BRGH=1: Strin= "19200"  : GoTo ExitOK 
    If Abs(Per -SPBRG38)<=2 Then  BRGH=1: Strin= "38400"  : GoTo ExitOK 
    If Abs(Per -SPBRG57)<=2 Then  BRGH=1: Strin= "57600"  : GoTo ExitOK 
    If Abs(Per -SPBRG115)<=2 Then BRGH=1: Strin= "115200" : GoTo ExitOK
    GoSub BEEP
'    hrsout " ERROR, TRY AGAIN",13,10
    Print At 1,1, " ERROR, TRY AGAIN" 
OnceAg: 
    DelayMS 200   
    Wend
     
ExitOK:
    GoSub BEEP
    Cls
    HRSOut  "BAUD=", Strin,LF,CR
    Print At 1,1, Strin, " Selected"
    Print At 2,1, " and stored" 
    SPBRG=Per
    EWrite SPBRGE, [SPBRG]
    EWrite BRGHE,  [BRGH] 
'    autobaud=0  
    DelayMS 1000
    Menu=mnuDisp        
Return

    ' ============== SERVICE SUB TO TEST AQUISITION LINEARITY 

Test_U:

    GIEH=0: GIEL=0
    
    HRSOut "Upwm ; Um ; Im ; Uac_m ; Id  ; Ids",LF,CR
    Print At 1,1, "P    U     I    "
    Print At 2,1, "Uac             "
    
'    DIM Ipwm AS WORD
    
    For vv=0 To 255
    
    HPWM PWM_U, vv,Fpwm
    HRSOut Dec vv," ; "
    Print At 1,2,DEC3 vv
    
    DelayMS 500
    
    ADCON0=CH_V
    DelayUS ADC_DELAY
    ADCON0.2 = 1
    While  ADCON0.2 = 1
    Wend
    Um.HighByte = ADRESH
    Um.LowByte = ADRESL
    HRSOut Dec Um," ; "
    Print At 1,7,DEC4 Um 
        
    DelayUS 5

    ADCON0=CH_I
    DelayUS ADC_DELAY
    ADCON0.2 = 1
    While  ADCON0.2 = 1
    Wend
    Im.HighByte = ADRESH
    Im.LowByte = ADRESL
    HRSOut Dec Im," ; "
    Print At 1,13,DEC4 Im
    
    DelayUS 5
    
    ADCON0=CH_Uac
    DelayUS ADC_DELAY
    ADCON0.2 = 1
    While  ADCON0.2 = 1
    Wend
    Uac_m.HighByte = ADRESH
    Uac_m.LowByte = ADRESL
    HRSOut Dec Uac_m," ; "
    Print At 2,4,DEC4 Uac_m
    GoSub READ_VARS
    
CONVERT_VARS1:
    Id=Im * Imax/ADCscale
    Id=Id * Ical
    Ids=Iset_m * Imax/PWMscale
    Ids=Ids * IsetC
    
    HRSOut DEC3 Id," ; ",DEC3 Ids,CR
    Next vv
'     RESET
     GoSub SET_OUT 
    GIEH=1 :  GIEL=1
    
Return

Test_I:

    GIEH=0: GIEL=0
    
    HRSOut "Ipwm",HT," Um ",HT," Im ",HT,"Iset_m",HT,"Uac_m ",HT," Id  ",HT," Ids",LF,CR
    Print At 1,1, "P    U     I    "
    Print At 2,1, "Uac             "
    vv=Iset
'    DIM Ipwm AS WORD
    HPWM PWM_U, 255,Fpwm
    For vv=0 To 255
    
    HPWM PWM_I, vv,Fpwm
    HRSOut Dec vv,HT
    Print At 1,2,DEC3 Iset
    
    DelayMS 500
    
    ADCON0=CH_V
    DelayUS ADC_DELAY
    ADCON0.2 = 1
    While  ADCON0.2 = 1
    Wend
    Um.HighByte = ADRESH
    Um.LowByte = ADRESL
    HRSOut Dec Um,HT
    Print At 1,7,DEC4 Um 
        
    DelayUS 5

    ADCON0=CH_I
    DelayUS ADC_DELAY
    ADCON0.2 = 1
    While  ADCON0.2 = 1
    Wend
    Im.HighByte = ADRESH
    Im.LowByte = ADRESL
    HRSOut Dec Im,HT
    Print At 1,13,DEC4 Im

    DelayUS 5
    
'I_set_m_Read:
    ADCON0=CH_Iset_m
    DelayUS ADC_DELAY
    ADCON0.2 = 1
    While  ADCON0.2 = 1
    Wend
    Iset_m.HighByte = ADRESH
    Iset_m.LowByte = ADRESL 
    HRSOut Dec Iset_m,HT           
    DelayUS 5
    
    
    ADCON0=CH_Uac
    DelayUS ADC_DELAY
    ADCON0.2 = 1
    While  ADCON0.2 = 1
    Wend
    Uac_m.HighByte = ADRESH
    Uac_m.LowByte = ADRESL
    HRSOut Dec Uac_m,HT
    Print At 2,4,DEC4 Uac_m
    GoSub READ_VARS
    
CONVERT_VARS:
    Id=Im * Imax/ADCscale
    Id=Id * Ical
    Ids=Iset_m * Imax/ADCscale
    Ids=Ids * IsetC +IsetC1
'     IDS=ISET * AIDS + BIDS
    
    HRSOut DEC3 Id,HT,DEC3 Ids,CR
    If Im > 1000 Then  EXIT_T
    Next vv
EXIT_T:
'     RESET
     GoSub SET_OUT 
    GIEH=1 :  GIEL=1
    
Return


Reset_Time:
    Hours=0
    Minutes=0
    Secs=0
Return           

TimeUpdate:
     Inc Secs
     If Secs=60 Then
     Inc Minutes
     Secs=0
     EndIf
     If Minutes=60 Then
     Inc Hours
     Minutes=0
     EndIf
     If Hours=25 Then
     Hours=0 
     EndIf    
Return

BEEP:
    Buzz=1
    DelayMS 100
    Buzz=0
Return  
    ' DISPLAY CURRENT PARAMETERS  
Settings:
    HRSOut "Umax=", Dec  Umax,HT,HT, "Imax=",Dec Imax,HT,HT,"IsetC1=",  DEC4 IsetC1, LF,CR
    HRSOut "Uset=", DEC3 Uset,HT,HT,HT,                    "Iset  =",  DEC3 Iset,  HT,  "TMR0L=", HEX  TMR0LOAD, LF,CR
    HRSOut "Umes=", DEC4 Um,  HT,   "Imes=", DEC4 Im,  HT, "Iset_m=",  DEC4 Iset_m,HT,  "SPBRG=", Dec  SPBRG, LF,CR
    HRSOut "Udis=", DEC3 Ud,  HT,   "Idis=", DEC3 Id,  HT, "Id_set=",  DEC3 Ids,   HT,  "Uac_m=", DEC4 Uac_m,LF,CR
    HRSOut "Ucal=", DEC4 Ucal,HT,   "Ical=", DEC4 Ical,HT, "IsetC =",  DEC4 IsetC, HT,  "IdisC=", DEC4 IdchC, LF,CR
    HRSOut "RTC=",  Dec RTC, HT,   "TIME ",DEC2 Hours,":",DEC2 Minutes,":",DEC2 Secs,LF,CR,LF,CR
Return 
Help:
     HRSOut "B - MEASURE S BATTERY",CR,LF
     HRSOut "C - send repetitive",CR,LF
     HRSOut "D - send U, I once",CR,LF
     HRSOut "E - TEST CHARGE",CR,LF 
     HRSOut "F - TEST_DISCHARGE", CR,LF    
     HRSOut "I - calibrate I", CR,LF
     HRSOut "K - CALIBRATE Iset",CR,LF
     HRSOut "L - CALIBRATE I DISCHARGE",CR,LF
     HRSOut "Y - linearity I LIM test",CR,LF
     HRSOut "S - display settings",CR,LF
     HRSOut "T - linearity test",CR,LF
     HRSOut "U - calibrate U", CR,LF
     
     HRSOut "uXXX - set U 0-255",CR,LF 
     HRSOut "iXXX - set i 0-255",CR,LF        
Return
    Include "AutoBaud.bas"    
End
F1_EOF:










